﻿namespace Kompozyt
{
    internal class Program
    {
        static void Main(string[] args)
        {
            Kierownik rektor = new Kierownik("Andrzej", "Sokala", "rektor");
            Kierownik dziekan = new Kierownik("Winicjusz", "Drozdowski", "dziekan WFAiIS");            
            Pracownik prodziekan = new Pracownik("Anna", "Bartkiewicz", "prodziekan ds. studentów");
            Kierownik kierownikKIS = new Kierownik("Rafał", "Adamczak", "kierownik KIS");
            Pracownik szaryPracownik = new Pracownik("Jacek", "Matulewski", "szaraczek");
            Pracownik innyPracownik = new Pracownik("Krzysztof", "Grąbczewski", "profesor");

            rektor.DodajPodwładnego(dziekan);
            dziekan.DodajPodwładnego(prodziekan);
            dziekan.DodajPodwładnego(kierownikKIS);
            kierownikKIS.DodajPodwładnego(szaryPracownik);
            kierownikKIS.DodajPodwładnego(dziekan); //cykl
            kierownikKIS.DodajPodwładnego(innyPracownik);

            //kierownikKIS.WyświetlInformacje();

            //rektor.WyświetlInformacje();
            //rektor.Resetuj();
            //rektor.WyświetlInformacje();

            rektor.PrzyjmijWizytę(new OdwiedzającyWyświetlającyInformacje());

            OdwiedzającySpłaszczającyDoListy osdl = new OdwiedzającySpłaszczającyDoListy();
            rektor.PrzyjmijWizytę(osdl);
            var lista = osdl.Lista;

            OdwiedzającyZliczający ozl = new OdwiedzającyZliczający();
            rektor.PrzyjmijWizytę(ozl);
            Console.WriteLine("Liczba elementów: " + ozl.Licznik);

            Console.WriteLine("Liczba elementów: " + rektor.Count());
            Console.WriteLine(rektor.Max(p => p.ToString().Length));
            Console.WriteLine(rektor.Average(p => p.ToString().Length));

            var zapytanie = from p in rektor
                            where p is Kierownik
                            select p.ToString();            

            List<int> listaInt = new List<int> { 0, 1, 2, 3, 4, 5 };
            IEnumerator<int> enumeratorInt = listaInt.GetEnumerator();
            while (enumeratorInt.MoveNext())
            {
                Console.WriteLine("Element: " + enumeratorInt.Current);
            }            
            enumeratorInt.Reset();
            while (enumeratorInt.MoveNext())
            {
                Console.WriteLine("Element: " + enumeratorInt.Current);
            }            
        }
    }
}